Index: /trunk/Packages/Common/AppModule.php
===================================================================
--- /trunk/Packages/Common/AppModule.php	(revision 69)
+++ /trunk/Packages/Common/AppModule.php	(revision 69)
@@ -0,0 +1,400 @@
+<?php
+
+/* This implementation will not support installation from remote source. Just
+ * installation of already presented modules mainly to persistence preparation.
+ */
+
+class ModuleType
+{
+  const System = 0;
+  const Normal = 1;
+  const Application = 2;
+}
+
+class ModuleAction
+{
+  const Start = 0;
+  const Stop = 1;
+  const Install = 2;
+  const Uninstall = 3;
+  const Upgrade = 4;
+  const Enable = 5;
+  const Disable = 6;
+}
+
+class ModuleCondition
+{
+  const All = 0;
+  const Enabled = 1;
+  const NotEnabled = 2;
+  const Installed = 3;
+  const NotInstalled = 4;
+  const Running = 5;
+  const NotRunning = 6;
+}
+
+class AppModule
+{
+  var $Id;
+  var $Name;
+  var $Title;
+  var $Version;
+  var $License;
+  var $Creator;
+  var $HomePage;
+  var $Description;
+  var $Running;
+  var $Enabled;
+  var $Installed;
+  var $InstalledVersion;
+  /** @var ModuleType */
+  var $Type;
+  var $Dependencies;
+  /** @var Database */
+  var $Database;
+  /** @var System */
+  var $System;
+  /** @var AppModuleManager */
+  var $Manager;
+  var $OnChange;
+
+  function __construct(System $System)
+  {
+    $this->System = &$System;
+    $this->Database = &$System->Database;
+    $this->Installed = false;
+    $this->Enabled = false;
+    $this->Running = false;
+    $this->HomePage = '';
+    $this->License = '';
+    $this->Version = '';
+    $this->Creator = '';
+    $this->Description = '';
+    $this->Dependencies = array();
+    $this->Type = ModuleType::Normal;
+  }
+
+  function Install()
+  {
+    if($this->Installed) return;
+    $List = array();
+    $this->Manager->EnumDependenciesCascade($this, $List, array(ModuleCondition::NotInstalled));
+    $this->Manager->Perform($List, array(ModuleAction::Install), array(ModuleCondition::NotInstalled));
+    $this->DoInstall();
+    $this->Installed = true;
+    $this->InstalledVersion = $this->Version;
+    $this->Manager->Modules[$this->Name] = $this;
+  }
+
+  function Uninstall()
+  {
+    if(!$this->Installed) return;
+    $this->Stop();
+    $this->Installed = false;
+    $List = array();
+    $this->Manager->EnumSuperiorDependenciesCascade($this, $List, array(ModuleCondition::Installed));
+    $this->Manager->Perform($List, array(ModuleAction::Uninstall), array(ModuleCondition::Installed));
+    $this->DoUninstall();
+  }
+
+  function Upgrade()
+  {
+    if(!$this->Installed) return;
+    if($this->InstalledVersion == $this->Version) return;
+    $List = array();
+    $this->Manager->EnumSuperiorDependenciesCascade($this, $List, array(ModuleCondition::Installed));
+    $this->Manager->Perform($List, array(ModuleAction::Upgrade), array(ModuleCondition::Installed));
+    $this->DoUpgrade();
+  }
+
+  function Reinstall()
+  {
+    $this->Uninstall();
+    // TODO: Install also back dependecies
+    $this->Install();
+  }
+
+  function Start()
+  {
+    if($this->Running) return;
+    if(!$this->Installed) return;
+    $List = array();
+    $this->Manager->EnumDependenciesCascade($this, $List, array(ModuleCondition::NotRunning));
+    $this->Manager->Perform($List, array(ModuleAction::Start), array(ModuleCondition::NotRunning));
+    $this->DoStart();
+    $this->Running = true;
+  }
+
+  function Stop()
+  {
+    if(!$this->Running) return;
+    $this->Running = false;
+    $List = array();
+    $this->Manager->EnumSuperiorDependenciesCascade($this, $List, array(ModuleCondition::Running));
+    $this->Manager->Perform($List, array(ModuleAction::Stop), array(ModuleCondition::Running));
+    $this->DoStop();
+  }
+
+  function Restart()
+  {
+    $this->Stop();
+    $this->Start();
+  }
+
+  function Enable()
+  {
+    if($this->Enabled) return;
+    if(!$this->Installed) return;
+    $List = array();
+    $this->Manager->EnumDependenciesCascade($this, $List, array(ModuleCondition::NotEnabled));
+    $this->Manager->Perform($List, array(ModuleAction::Enable), array(ModuleCondition::NotEnabled));
+    $this->Enabled = true;
+  }
+
+  function Disable()
+  {
+    if(!$this->Enabled) return;
+    $this->Stop();
+    $this->Enabled = false;
+    $List = array();
+    $this->Manager->EnumSuperiorDependenciesCascade($this, $List, array(ModuleCondition::Enabled));
+    $this->Manager->Perform($List, array(ModuleAction::Disable), array(ModuleCondition::Enabled));
+  }
+
+  protected function DoStart()
+  {
+  }
+
+  protected function DoStop()
+  {
+  }
+
+  protected function DoInstall()
+  {
+  }
+
+  protected function DoUninstall()
+  {
+  }
+
+  protected function DoUpgrade()
+  {
+
+  }
+}
+
+/* Manage installed modules */
+class AppModuleManager
+{
+  var $Modules;
+  var $System;
+  var $FileName;
+  var $ModulesDir;
+  var $OnLoadModules;
+
+  function __construct(System $System)
+  {
+    $this->Modules = array();
+    $this->System = &$System;
+    $this->FileName = dirname(__FILE__).'/../../Config/ModulesConfig.php';
+    $this->ModulesDir = dirname(__FILE__).'/../../Modules';
+  }
+
+  function Perform($List, $Actions, $Conditions = array(ModuleCondition::All))
+  {
+    foreach($List as $Index => $Module)
+    {
+      if(in_array(ModuleCondition::All, $Conditions) or
+        ($Module->Running and in_array(ModuleCondition::Running, $Conditions)) or
+        (!$Module->Running and in_array(ModuleCondition::NotRunning, $Conditions)) or
+        ($Module->Installed and in_array(ModuleCondition::Installed, $Conditions)) or
+        (!$Module->Installed and in_array(ModuleCondition::NotInstalled, $Conditions)) or
+        ($Module->Enabled and in_array(ModuleCondition::Enabled, $Conditions)) or
+        (!$Module->Enabled and in_array(ModuleCondition::NotEnabled, $Conditions)))
+      {
+        foreach($Actions as $Action)
+        {
+          if($Action == ModuleAction::Start) $Module->Start();
+          if($Action == ModuleAction::Stop) $Module->Stop();
+          if($Action == ModuleAction::Install) $Module->Install();
+          if($Action == ModuleAction::Uninstall) $Module->Uninstall();
+          if($Action == ModuleAction::Enable) $Module->Enable();
+          if($Action == ModuleAction::Disable) $Module->Disable();
+          if($Action == ModuleAction::Upgrade) $Module->Upgrade();
+        }
+      }
+    }
+  }
+
+  function EnumDependenciesCascade($Module, &$List, $Conditions = array(ModuleCondition::All))
+  {
+    foreach($Module->Dependencies as $Dependency)
+    {
+      if(!array_key_exists($Dependency, $this->Modules))
+        throw new Exception(sprintf(T('Module "%s" dependency "%s" not found'), $Module->Name, $Dependency));
+      $DepModule = $this->Modules[$Dependency];
+      if(in_array(ModuleCondition::All, $Conditions) or
+        ($Module->Running and in_array(ModuleCondition::Running, $Conditions)) or
+        (!$Module->Running and in_array(ModuleCondition::NotRunning, $Conditions)) or
+        ($Module->Enabled and in_array(ModuleCondition::Enabled, $Conditions)) or
+        (!$Module->Enabled and in_array(ModuleCondition::NotEnabled, $Conditions)) or
+        ($Module->Installed and in_array(ModuleCondition::Installed, $Conditions)) or
+        (!$Module->Installed and in_array(ModuleCondition::NotInstalled, $Conditions)))
+      {
+        array_push($List, $DepModule);
+        $this->EnumDependenciesCascade($DepModule, $List, $Conditions);
+      }
+    }
+  }
+
+  function EnumSuperiorDependenciesCascade($Module, &$List, $Conditions = array(ModuleCondition::All))
+  {
+    foreach($this->Modules as $RefModule)
+    {
+      if(in_array($Module->Name, $RefModule->Dependencies) and
+          (in_array(ModuleCondition::All, $Conditions) or
+          ($Module->Running and in_array(ModuleCondition::Running, $Conditions)) or
+          (!$Module->Running and in_array(ModuleCondition::NotRunning, $Conditions)) or
+          ($Module->Enabled and in_array(ModuleCondition::Enabled, $Conditions)) or
+          (!$Module->Enabled and in_array(ModuleCondition::NotEnabled, $Conditions)) or
+          ($Module->Installed and in_array(ModuleCondition::Installed, $Conditions)) or
+          (!$Module->Installed and in_array(ModuleCondition::NotInstalled, $Conditions))))
+      {
+        array_push($List, $RefModule);
+        $this->EnumSuperiorDependenciesCascade($RefModule, $List, $Conditions);
+      }
+    }
+  }
+
+  function Start()
+  {
+    $this->LoadModules();
+    if(file_exists($this->FileName)) $this->LoadState();
+    $this->StartEnabled();
+  }
+
+  function StartAll()
+  {
+    $this->Perform($this->Modules, array(ModuleAction::Start));
+  }
+
+  function StartEnabled()
+  {
+    $this->Perform($this->Modules, array(ModuleAction::Start), array(ModuleCondition::Enabled));
+  }
+
+  function StopAll()
+  {
+    $this->Perform($this->Modules, array(ModuleAction::Stop));
+  }
+
+  function InstallAll()
+  {
+    $this->Perform($this->Modules, array(ModuleAction::Install));
+    $this->SaveState();
+  }
+
+  function UninstallAll()
+  {
+    $this->Perform($this->Modules, array(ModuleAction::Uninstall));
+    $this->SaveState();
+  }
+
+  function EnableAll()
+  {
+    $this->Perform($this->Modules, array(ModuleAction::Enable));
+    $this->SaveState();
+  }
+
+  function DisableAll()
+  {
+    $this->Perform($this->Modules, array(ModuleAction::Disable));
+    $this->SaveState();
+  }
+
+  function ModulePresent($Name)
+  {
+    return(array_key_exists($Name, $this->Modules));
+  }
+
+  function ModuleEnabled($Name)
+  {
+    return(array_key_exists($Name, $this->Modules) and $this->Modules[$Name]->Enabled);
+  }
+
+  function ModuleRunning($Name)
+  {
+    return(array_key_exists($Name, $this->Modules) and $this->Modules[$Name]->Running);
+  }
+
+  /* @return Module */
+  function SearchModuleById($Id)
+  {
+    foreach($this->Modules as $Module)
+    {
+      //DebugLog($Module->Name.' '.$Module->Id);
+      if($Module->Id == $Id) return($Module->Name);
+    }
+    return('');
+  }
+
+  function LoadState()
+  {
+    $ConfigModules = array();
+    include($this->FileName);
+    foreach($ConfigModules as $Mod)
+    {
+      if(array_key_exists($Mod['Name'], $this->Modules))
+      {
+        $this->Modules[$Mod['Name']] = $this->Modules[$Mod['Name']];
+        $this->Modules[$Mod['Name']]->Enabled = $Mod['Enabled'];
+        $this->Modules[$Mod['Name']]->Installed = $Mod['Installed'];
+        $this->Modules[$Mod['Name']]->InstalledVersion = $Mod['Version'];
+      }
+    }
+  }
+
+  function SaveState()
+  {
+    $Data = array();
+    foreach($this->Modules as $Module)
+    {
+      $Data[] = array('Name' => $Module->Name, 'Enabled' => $Module->Enabled,
+        'Version' => $Module->Version, 'Installed' => $Module->Installed);
+    }
+    file_put_contents($this->FileName, "<?php \n\n\$ConfigModules = ".var_export($Data, true).";\n");
+  }
+
+  function RegisterModule(AppModule $Module)
+  {
+    $this->Modules[$Module->Name] = &$Module;
+    $Module->Manager = &$this;
+    $Module->OnChange = &$this->OnModuleChange;
+  }
+
+  function UnregisterModule(AppModule $Module)
+  {
+    unset($this->Modules[array_search($Module, $this->Modules)]);
+  }
+
+  function LoadModulesFromDir($Directory)
+  {
+    $List = scandir($Directory);
+    foreach($List as $Item)
+    {
+      if(is_dir($Directory.'/'.$Item) and ($Item != '.') and ($Item != '..') and ($Item != '.svn'))
+      {
+        include_once($Directory.'/'.$Item.'/'.$Item.'.php');
+        $ModuleName = 'Module'.$Item;
+        $this->RegisterModule(new $ModuleName($this->System));
+      }
+    }
+  }
+
+  function LoadModules()
+  {
+    if(method_exists($this->OnLoadModules[0], $this->OnLoadModules[1]))
+      $this->OnLoadModules();
+    else $this->LoadModulesFromDir($this->ModulesDir);
+  }
+}
Index: /trunk/Packages/Common/Application.php
===================================================================
--- /trunk/Packages/Common/Application.php	(revision 69)
+++ /trunk/Packages/Common/Application.php	(revision 69)
@@ -0,0 +1,22 @@
+<?php
+
+class Application extends System
+{
+  var $Name;
+  /** @var AppModuleManager */
+  var $ModuleManager;
+  var $Modules;
+
+  function __construct()
+  {
+    parent::__construct();
+    $this->Name = 'Application';
+    $this->ModuleManager = new AppModuleManager($this);
+    $this->Modules = array();
+  }
+
+  function Run()
+  {
+
+  }
+}
Index: /trunk/Packages/Common/Base.php
===================================================================
--- /trunk/Packages/Common/Base.php	(revision 69)
+++ /trunk/Packages/Common/Base.php	(revision 69)
@@ -0,0 +1,41 @@
+<?php
+
+class System
+{
+  /* @var Database */
+  var $Database;
+
+  function __construct()
+  {
+    $this->Database = new Database();
+  }
+}
+
+class Base
+{
+  /** @var Application */
+  var $System;
+  /* @var Database */
+  var $Database;
+
+  function __construct(Application $System)
+  {
+    $this->System = &$System;
+    $this->Database = &$System->Database;
+  }
+}
+
+class Model extends Base
+{
+
+}
+
+class View extends Base
+{
+
+}
+
+class Controller extends Base
+{
+
+}
Index: /trunk/Packages/Common/Common.php
===================================================================
--- /trunk/Packages/Common/Common.php	(revision 68)
+++ /trunk/Packages/Common/Common.php	(revision 69)
@@ -10,4 +10,13 @@
 include_once(dirname(__FILE__).'/VarDumper.php');
 include_once(dirname(__FILE__).'/Error.php');
+include_once(dirname(__FILE__).'/Base.php');
+include_once(dirname(__FILE__).'/Application.php');
+include_once(dirname(__FILE__).'/AppModule.php');
+include_once(dirname(__FILE__).'/Config.php');
+include_once(dirname(__FILE__).'/Page.php');
+include_once(dirname(__FILE__).'/Locale.php');
+include_once(dirname(__FILE__).'/Update.php');
+include_once(dirname(__FILE__).'/Setup.php');
+include_once(dirname(__FILE__).'/Table.php');
 
 class PackageCommon
@@ -15,4 +24,5 @@
   var $Name;
   var $Version;
+  var $ReleaseDate;
   var $License;
   var $Creator;
@@ -22,5 +32,6 @@
   {
     $this->Name = 'Common';
-    $this->Version = '1.1';
+    $this->Version = '1.2';
+    $this->ReleaseDate = strtotime('2016-01-22');
     $this->Creator = 'Chronos';
     $this->License = 'GNU/GPL';
@@ -28,2 +39,85 @@
   }
 }
+
+class Paging
+{
+  var $TotalCount;
+  var $ItemPerPage;
+  var $Around;
+  var $SQLLimit;
+  var $Page;
+
+  function __construct(System $System)
+  {
+    $this->ItemPerPage = $System->Config['Web']['ItemsPerPage'];
+    $this->Around = $System->Config['Web']['VisiblePagingItems'];
+  }
+
+  function Show()
+  {
+    $QueryItems = GetQueryStringArray($_SERVER['QUERY_STRING']);
+
+    $Result = '';
+    if(array_key_exists('all', $QueryItems))
+    {
+      $PageCount = 1;
+      $ItemPerPage = $this->TotalCount;
+    } else
+    {
+      $ItemPerPage = $this->ItemPerPage;
+      $Around = round($this->Around / 2);
+      $PageCount = floor($this->TotalCount / $ItemPerPage) + 1;
+    }
+
+    if(!array_key_exists('Page', $_SESSION)) $_SESSION['Page'] = 0;
+    if(array_key_exists('page', $_GET)) $_SESSION['Page'] = $_GET['page'] * 1;
+    if($_SESSION['Page'] < 0) $_SESSION['Page'] = 0;
+    if($_SESSION['Page'] >= $PageCount) $_SESSION['Page'] = $PageCount - 1;
+    $CurrentPage = $_SESSION['Page'];
+
+    $Result .= 'Počet položek: <strong>'.$this->TotalCount.'</strong> &nbsp; Stránky: ';
+
+    $Result = '';
+    if($PageCount > 1)
+    {
+      if($CurrentPage > 0)
+      {
+        $QueryItems['page'] = 0;
+        $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&lt;&lt;</a> ';
+        $QueryItems['page'] = ($CurrentPage - 1);
+        $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&lt;</a> ';
+      }
+      $PagesMax = $PageCount - 1;
+      $PagesMin = 0;
+      if($PagesMax > ($CurrentPage + $Around)) $PagesMax = $CurrentPage + $Around;
+      if($PagesMin < ($CurrentPage - $Around))
+      {
+        $Result.= ' ... ';
+        $PagesMin = $CurrentPage - $Around;
+      }
+      for($i = $PagesMin; $i <= $PagesMax; $i++)
+      {
+        if($i == $CurrentPage) $Result.= '<strong>'.($i + 1).'</strong> ';
+        else {
+         $QueryItems['page'] = $i;
+         $Result .= '<a href="?'.SetQueryStringArray($QueryItems).'">'.($i + 1).'</a> ';
+        }
+      }
+      if($PagesMax < ($PageCount - 1)) $Result .= ' ... ';
+      if($CurrentPage < ($PageCount - 1))
+      {
+        $QueryItems['page'] = ($CurrentPage + 1);
+        $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&gt;</a> ';
+        $QueryItems['page'] = ($PageCount - 1);
+        $Result.= '<a href="?'.SetQueryStringArray($QueryItems).'">&gt;&gt;</a>';
+      }
+    }
+    $QueryItems['all'] = '1';
+    if($PageCount > 1) $Result.= ' <a href="?'.SetQueryStringArray($QueryItems).'">Vše</a>';
+
+    $Result = '<div style="text-align: center">'.$Result.'</div>';
+    $this->SQLLimit = ' LIMIT '.$CurrentPage * $ItemPerPage.', '.$ItemPerPage;
+    $this->Page = $CurrentPage;
+    return($Result);
+  }
+}
Index: /trunk/Packages/Common/Config.php
===================================================================
--- /trunk/Packages/Common/Config.php	(revision 69)
+++ /trunk/Packages/Common/Config.php	(revision 69)
@@ -0,0 +1,56 @@
+<?php
+
+class Config
+{
+  var $Data;
+
+  function __construct()
+  {
+    $this->Data = array();
+  }
+
+  function ReadValue($Name)
+  {
+    if(!is_array($Name)) $Name = explode('/', $Name);
+    $Last = array_pop($Name);
+    $Data = &$this->Data;
+    foreach($Name as $Item)
+    {
+      $Data = &$Data[$Item];
+    }
+    return($Data[$Last]);
+  }
+
+  function WriteValue($Name, $Value)
+  {
+    if(!is_array($Name)) $Name = explode('/', $Name);
+    $Last = array_pop($Name);
+    $Data = &$this->Data;
+    foreach($Name as $Item)
+    {
+      $Data = &$Data[$Item];
+    }
+    $Data[$Item] = $Value;
+  }
+
+  function LoadFromFile($FileName)
+  {
+    $ConfigData = array();
+    include $FileName;
+    foreach($this->Data as $Index => $Item)
+    {
+      if(array_key_exits($Index, $ConfigData))
+        $this->Data[$Index] = $ConfigData[$Index];
+    }
+  }
+
+  function SaveToFile($FileName)
+  {
+    file_put_contents($FileName, "<?php \n\n\$ConfigData = ".var_export($this->Data, true).";\n");
+  }
+
+  function GetAsArray()
+  {
+    return($this->Data);
+  }
+}
Index: /trunk/Packages/Common/Database.php
===================================================================
--- /trunk/Packages/Common/Database.php	(revision 68)
+++ /trunk/Packages/Common/Database.php	(revision 69)
@@ -2,5 +2,5 @@
 
 // Extended database class
-// Date: 2011-11-25
+// Date: 2016-01-11
 
 class DatabaseResult
@@ -27,20 +27,27 @@
 class Database
 {
-  var $Prefix = '';
+  var $Prefix;
   var $Functions;
   var $Type;
   var $PDO;
-  var $Error = '';
+  var $Error;
   var $insert_id;
-  var $LastQuery = '';
+  var $LastQuery;
   var $ShowSQLError;
   var $ShowSQLQuery;
+  var $LogSQLQuery;
+  var $LogFile;
 
   function __construct()
   {
+    $this->Prefix = '';
+    $this->Functions = array('NOW()', 'CURDATE()', 'CURTIME()', 'UUID()');
     $this->Type = 'mysql';  // mysql, pgsql
+    $this->Error = '';
+    $this->LastQuery = '';
     $this->ShowSQLError = false;
     $this->ShowSQLQuery = false;
-    $this->Functions = array('NOW()', 'CURDATE()', 'CURTIME()', 'UUID()');
+    $this->LogSQLQuery = false;
+    $this->LogFile = dirname(__FILE__).'/../../Query.log';
   }
 
@@ -77,8 +84,14 @@
   function query($Query)
   {
-    if(!$this->Connected()) throw new Exception('Not connected to database');
+    if(!$this->Connected()) throw new Exception(T('Not connected to database'));
+    if(($this->ShowSQLQuery == true) or ($this->LogSQLQuery == true)) $QueryStartTime = microtime();
     $this->LastQuery = $Query;
+    if(($this->ShowSQLQuery == true) or ($this->LogSQLQuery == true))
+      $Duration = ' ; '.round(microtime() - $QueryStartTime, 4). ' s';
+    if($this->LogSQLQuery == true)
+      file_put_contents($this->LogFile, $Query.$Duration."\n", FILE_APPEND);
     if($this->ShowSQLQuery == true)
-      echo('<div style="border-bottom-width: 1px; border-bottom-style: solid; padding-bottom: 3px; padding-top: 3px; font-size: 12px; font-family: Arial;">'.$Query.'</div>'."\n");
+      echo('<div style="border-bottom-width: 1px; border-bottom-style: solid; '.
+      'padding-bottom: 3px; padding-top: 3px; font-size: 12px; font-family: Arial;">'.$Query.$Duration.'</div>'."\n");
     $Result = new DatabaseResult();
     $Result->PDOStatement = $this->PDO->query($Query);
@@ -175,4 +188,9 @@
   }
 
+  function quote($Text)
+  {
+    return($this->PDO->quote($Text));
+  }
+
   public function __sleep()
   {
Index: /trunk/Packages/Common/Error.php
===================================================================
--- /trunk/Packages/Common/Error.php	(revision 68)
+++ /trunk/Packages/Common/Error.php	(revision 69)
@@ -74,5 +74,5 @@
     die();
   }
-  
+
   function ShowDefaultError($Message)
   {
@@ -112,5 +112,5 @@
 
     foreach($this->OnError as $OnError)
-      $OnError[0]->$OnError[1]($Error);
+      call_user_func($OnError, $Error);
   }
 }
Index: /trunk/Packages/Common/Locale.php
===================================================================
--- /trunk/Packages/Common/Locale.php	(revision 69)
+++ /trunk/Packages/Common/Locale.php	(revision 69)
@@ -0,0 +1,249 @@
+<?php
+
+class LocaleText
+{
+  var $Data;
+  var $Code;
+  var $Title;
+
+  function __construct()
+  {
+    $this->Data = array();
+    $this->Code = 'en';
+    $this->Title = 'English';
+  }
+
+  function Load()
+  {
+  }
+
+  function Translate($Text, $Group = '')
+  {
+    if(array_key_exists($Text, $this->Data[$Group]) and ($this->Data[$Group][$Text] != ''))
+      return($this->Data[$Group][$Text]);
+      else return($Text);
+  }
+
+  function TranslateReverse($Text, $Group = '')
+  {
+    $Key = array_search($Text, $this->Data[$Group]);
+    if(($Key === FALSE) or ($this->Data[$Group][$Key] == '')) return($Text);
+      else return($Key);
+  }
+}
+
+class LocaleFile extends Model
+{
+  var $Texts;
+  var $Dir;
+
+  function __construct(System $System)
+  {
+    parent::__construct($System);
+    $this->Texts = new LocaleText();
+  }
+
+  function Load($Language)
+  {
+    $FileName = $this->Dir.'/'.$Language.'.php';
+    if(file_exists($FileName)) {
+      include_once($FileName);
+      $ClassName = 'LocaleText'.$Language;
+      $this->Texts = new $ClassName();
+    } else throw new Exception(sprintf(T('Language file %s not found'), $FileName));
+    $this->Texts->Load();
+  }
+
+  function AnalyzeCode($Path)
+  {
+    // Search for php files
+    $FileList = scandir($Path);
+    foreach($FileList as $FileName)
+    {
+      $FullName = $Path.'/'.$FileName;
+      if(($FileName == '.') or ($FileName == '..')) ; // Skip virtual items
+      else if(substr($FileName, 0, 1) == '.') ; // Skip Linux hidden files
+      else if(is_dir($FullName)) $this->AnalyzeCode($FullName);
+      else if(file_exists($FullName))
+      {
+        if(substr($FullName, -4) == '.php')
+        {
+          $Content = file_get_contents($FullName);
+          // Search occurence of T() function
+          while(strpos($Content, 'T(') !== false)
+          {
+            $Previous = strtolower(substr($Content, strpos($Content, 'T(') - 1, 1));
+            $Content = substr($Content, strpos($Content, 'T(') + 2);
+            $Ord = ord($Previous);
+            //echo($Ord.',');
+            if(!(($Ord >= ord('a')) and ($Ord <= ord('z'))))
+            {
+              // Do for non-alpha previous character
+              $Original = substr($Content, 0, strpos($Content, ')'));
+              $Original2 = '';
+              if((substr($Original, 0, 1) == "'") and (substr($Original, -1, 1) == "'"))
+                $Original2 = substr($Original, 1, -1);
+              if((substr($Original, 0, 1) == '"') and (substr($Original, -1, 1) == '"'))
+                $Original2 = substr($Original, 1, -1);
+              if($Original2 != '')
+              {
+                if(!array_key_exists($Original2, $this->Texts->Data))
+                  $this->Texts->Data[$Original2] = '';
+              }
+            }
+          }
+        }
+      }
+    }
+  }
+
+  function SaveToFile($FileName)
+  {
+    $Content = '<?php'."\n".
+    ''."\n".
+    'class LocaleText'.$this->Texts->Code.' extends LocaleText'."\n".
+    '{'."\n".
+    '  function Load()'."\n".
+    '  {'."\n".
+    '    $this->Code = \''.$this->Texts->Code.'\';'."\n".
+    '    $this->Title = \''.$this->Texts->Title.'\';'."\n".
+    '    $this->Data = array('."\n";
+    foreach($this->Texts->Data as $Index => $Item)
+    {
+      $Content .= "      '".$Index."' => '".$Item."',\n";
+    }
+    $Content .= '    );'."\n".
+    '  }'."\n".
+    '}'."\n";
+    file_put_contents($FileName, $Content);
+  }
+
+  function LoadFromDatabase($Database, $LangCode)
+  {
+    $DbResult = $Database->select('Language', '*', 'Code='.$Database->quote($LangCode));
+    if($DbResult->num_rows > 0)
+    {
+      $Language = $DbResult->fetch_assoc();
+      $this->Texts->Data = array();
+      $DbResult = $Database->select('Locale', '`Original`, `Translated`', '`Language`='.$Language['Id']);
+      while($DbRow = $DbResult->fetch_assoc())
+        $this->Texts->Data[$DbRow['Original']] = $DbRow['Translated'];
+    }
+  }
+
+  function SaveToDatabase(Database $Database, $LangCode)
+  {
+    $DbResult = $Database->select('Language', '*', 'Code='.$Database->quote($LangCode));
+    if($DbResult->num_rows > 0)
+    {
+      $Language = $DbResult->fetch_assoc();
+      $Database->delete('Locale', '`Language`='.$Language['Id']);
+      foreach($this->Texts->Data as $Index => $Item)
+        $Database->query('INSERT INTO `Locale` (`Language`,`Original`,`Translated`) '.
+        'VALUES('.$Language['Id'].','.$Database->quote($Index).','.$Database->quote($Item).')');
+    }
+  }
+
+  function UpdateToDatabase(Database $Database, $LangCode)
+  {
+    $DbResult = $Database->select('Language', '*', '`Code`='.$Database->quote($LangCode));
+    if($DbResult->num_rows > 0)
+    {
+      $Language = $DbResult->fetch_assoc();
+      foreach($this->Texts->Data as $Index => $Item)
+      {
+        $DbResult = $Database->select('Locale', '*', '(`Original` ='.$Database->quote($Index).
+          ') AND (`Language`='.($Language['Id']).')');
+        if($DbResult->num_rows > 0)
+        $Database->update('Locale', '(`Language`='.($Language['Id']).') AND '.
+          '(`Original` ='.$Database->quote($Index).')', array('Translated' => $Item));
+        else $Database->insert('Locale', array('Language' => $Language['Id'],
+         'Original' => $Index, 'Translated' => $Item));
+      }
+    }
+  }
+}
+
+class LocaleManager extends Model
+{
+  var $CurrentLocale;
+  var $Codes;
+  var $Dir;
+  var $LangCode;
+  var $DefaultLangCode;
+  var $Available;
+
+  function __construct(System $System)
+  {
+    parent::__construct($System);
+    $this->Codes = array('en');
+    $this->CurrentLocale = new LocaleFile($System);
+    $this->LangCode = 'en';
+    $this->DefaultLangCode = 'en';
+    $this->Available = array();
+  }
+
+  function LoadAvailable()
+  {
+    $this->Available = array();
+    $FileList = scandir($this->Dir);
+    foreach($FileList as $FileName)
+    {
+      if(substr($FileName, -4) == '.php')
+      {
+        $Code = substr($FileName, 0, -4);
+        $Locale = new LocaleFile($this->System);
+        $Locale->Dir = $this->Dir;
+        $Locale->Load($Code);
+        $this->Available['Code'] = array('Code' => $Code, 'Title' => $Locale->Texts->Title);
+      }
+    }
+  }
+
+  function UpdateAll($Directory)
+  {
+    $Locale = new LocaleFile($this->System);
+    $Locale->AnalyzeCode($Directory);
+    $FileList = scandir($this->Dir);
+    foreach($FileList as $FileName)
+    {
+      if(substr($FileName, -4) == '.php')
+      {
+        $FileLocale = new LocaleFile($this->System);
+        $FileLocale->Dir = $this->Dir;
+        $FileLocale->Load(substr($FileName, 0, -4));
+
+        // Add new
+        foreach($Locale->Texts->Data as $Index => $Item)
+          if(!array_key_exists($Index, $FileLocale->Texts->Data))
+            $FileLocale->Texts->Data[$Index] = $Item;
+        // Remove old
+        foreach($FileLocale->Texts->Data as $Index => $Item)
+          if(!array_key_exists($Index, $Locale->Texts->Data))
+            unset($FileLocale->Texts->Data[$Index]);
+        $FileLocale->UpdateToDatabase($this->System->Database, $FileLocale->Texts->Code);
+        $FileName = $this->Dir.'/'.$FileLocale->Texts->Code.'.php';
+        $FileLocale->SaveToFile($FileName);
+      }
+    }
+    $this->CurrentLocale->Load($this->CurrentLocale->Texts->Code);
+  }
+
+  function LoadLocale($Code)
+  {
+    if(array_key_exists($Code, $this->Available))
+    {
+      $this->CurrentLocale->Dir = $this->Dir;
+      $this->CurrentLocale->Load($Code);
+    } else throw new Exception(sprintf(T('Unsupported locale code %s'), $Code));
+  }
+}
+
+// Short named global translation function
+function T($Text, $Group = '')
+{
+  global $GlobalLocaleManager;
+
+  if(isset($GlobalLocaleManager)) return($GlobalLocaleManager->CurrentLocale->Texts->Translate($Text, $Group));
+    else return($Text);
+}
